//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ Arbol.cpp
//+
//+ El rbol que se genera en la bsqueda
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"
#include "Arbol.h"
#include "Notador.h"

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ class PV
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// Limpia la PV
void PV::Limpiar() {
    memset(longitudPV, 0, sizeof(longitudPV));
    memset(pv, 0, sizeof(pv));
}

// Escribe la PV en un string
string PV::Obtener(void) const {
    string ret = "";
    for(int i = 1; i < longitudPV[1]; i++) {
        ret += Notador::ObtenerNotacion(pv[1][i]);
        ret += " ";
    }

    return ret;
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ class Arbol
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ HISTORIA Y KILLERS
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

Arbol::Arbol(const Tablero *t) {
    listaMovimientos = new ListaMovimientos[MAX_PLY];
    if(listaMovimientos != NULL) {
        for(int i = 0; i < MAX_PLY; i++) {
            listaMovimientos[i].SetArbol(this);
            listaMovimientos[i].SetTablero(t);
        }
    }
}

Arbol::~Arbol(void) {
    delete[] listaMovimientos;
    listaMovimientos = NULL;
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ HISTORIA Y KILLERS
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// Limpia la heurstica de la historia
void Arbol::LimpiarHH(void) {
    memset(heuristicaHistoria, 0, sizeof(heuristicaHistoria));
}

// Limpia los killers
void Arbol::LimpiarKillers(void) {
    memset(killer1, 0, sizeof(killer1));
    memset(killer2, 0, sizeof(killer2));
}

// Actualiza la heurstica de la historia
void Arbol::ActualizarHH(int profundidad, Movimiento mov) {
	heuristicaHistoria[mov.GetPieza()][mov.Destino()] += profundidad;
}

// Actualiza los killers
void Arbol::ActualizarKillers(int ply, Movimiento mov) {
    assert(!mov.EsNulo());
    assert(ply >= 0 && ply < MAX_PLY);
    if(mov == killer1[ply])
        return;
    killer2[ply] = killer1[ply];
    killer1[ply] = mov;
}

// Limpia los contadores de nodos en raz
void Arbol::LimpiarNodosRaiz(void) {
    memset(numeroNodosRaiz, 0, sizeof(numeroNodosRaiz));
}

