//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ Color.h
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#pragma once

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ CONSTANTES ENUMERADAS
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

enum Color {
    Blancas, Negras
};

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ FUNCIONES AUXILIARES
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

inline bool ColorValido(Color c) { return (c == Blancas || c == Negras); }
inline Color ColorContrario(Color c) { return (c == Blancas ? Negras : Blancas); }

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ OPERADORES
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// Para mostrar un color por pantalla
extern inline ostream& operator<<(ostream& salida, Color c) {
    cout << (c == Blancas ? "Blancas" : "Negras");
    return salida;
}
