//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ ComandoUCI.cpp
//+
//+ Un comando en el protocolo UCI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"
#include "ComandoUCI.h"

namespace UCI {

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ class ComandoUCI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// Constructor
ComandoUCI::ComandoUCI(string nombre, ConsolaUCI *con, void(ConsolaUCI::*func)(string &), bool debug, bool signal)
: nombreComando(nombre), consola(con), funcionEjecucion(func), esDebug(debug), mandaSignal(signal) {}

// Devuelve el nombre de la opcin
string ComandoUCI::GetNombre(void) const {
    return nombreComando;
}

// Devuelve true si el comando es de debug
bool ComandoUCI::EsDebug(void) const {
    return esDebug;
}

// Devuelve true si el comando se encarga de mandar la seal de fin de proceso input
bool ComandoUCI::MandaSignal(void) const {
    return mandaSignal;
}

// Ejecuta el comando
void ComandoUCI::Ejecutar(string &argumentos) {
    // Llamamos a la funcin de consola
    (consola->*(funcionEjecucion))(argumentos);
}

// Operador de igualdad
ComandoUCI& ComandoUCI::operator=(const ComandoUCI& comando) {
    nombreComando = comando.nombreComando;
    consola = comando.consola;
    funcionEjecucion = comando.funcionEjecucion;
    esDebug = comando.esDebug;
    mandaSignal = comando.mandaSignal;
    return *this;
}

}; // namespace UCI
