//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ ComandoUCI.h
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#pragma once

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ DECLARACION PREVIA DE CLASES
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

namespace UCI {

class ConsolaUCI;

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ class ComandoUCI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

class ComandoUCI {
public:
    // Constructor
    ComandoUCI(string nombre, ConsolaUCI* con, void(ConsolaUCI::*func)(string &), bool debug = false, bool signal = false);

    // Devuelve el nombre de la opcin
    string GetNombre(void) const;

    // Devuelve true si el comando es de debug
    bool EsDebug(void) const;

    // Devuelve true si el comando se encarga de mandar la seal de fin de proceso input
    bool MandaSignal(void) const;

    // Ejecuta el comando
    void Ejecutar(string &argumentos);

    // Operador de igualdad
    ComandoUCI& operator=(const ComandoUCI& comando);

private:
    ConsolaUCI* consola;
    string nombreComando;
    void (ConsolaUCI::*funcionEjecucion)(string&);
    bool mandaSignal;
    bool esDebug;
};

}; // namespace UCI
