//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ Config.cpp
//+
//+ La configuracin del motor
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"
#include "Config.h"

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ DATOS NAMESPACE
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

int Config::sizeHashMegas;
string Config::engineAbout;
bool Config::mostrarResumenBusqueda;

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ namespace Bitboards
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// Establece la configuracin inicial del programa
void Config::EstablecerConfiguracionInicial(void) {
    // Hash
    sizeHashMegas = 32;
    // Consola
    engineAbout = "HeavyChess Alpha [" + string(VERSION) + "] by Federico Corigliano";    
    // Busqueda
    mostrarResumenBusqueda = true;

    MostrarConfiguracion();
}

// Muestra las opciones actuales
void Config::MostrarConfiguracion(void) {
#if defined(DEBUG_MOSTRAR)
    cout << "OPCIONES ACTUALES:" << endl;
    cout << "Tabla Hash: " << sizeHashMegas << " MBs" << endl;
    cout << "UCIEngineAbout: " << engineAbout << endl;
    cout << "ResumenBusqueda: " << ValorVerdad(mostrarResumenBusqueda) << endl;
    cout << DIVISOR << endl;
#endif
}
