//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ ConsolaUCI.h
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#pragma once

#include "Consola.h"
#include "ComandoUCI.h"
#include "OpcionUCI.h"
#include "SalidaUCI.h"

namespace UCI {

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ class ConsolaUCI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

class ConsolaUCI : public Consola {
public:
    // Constructor
    ConsolaUCI(void);

    // Destructor
    virtual ~ConsolaUCI(void);

    // Procesa la input recibida
    virtual void ProcesarInput(void);

private:

    //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //+ LISTA DE COMANDOS
    //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    // Comandos Estandar
    void cmdGo(string &args);
    void cmdUci(string &args);
    void cmdIsReady(string &args);
    void cmdPosition(string &args);
    void cmdStop(string &args);
    void cmdQuit(string &args);
    void cmdUciNewGame(string &args);
    void cmdSetOption(string &args);

    // Comandos Extra
    void cmdTablero(string &args);
    void cmdBitboards(string &args);
    void cmdPerft(string &args);
    void cmdDivide(string &args);
    void cmdListaMovs(string &args);
    void cmdEval(string &args);
    void cmdMove(string &args);
    void cmdPositionTest(string &args);
    void cmdSEE(string &args);

    //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //+ LISTA DE OPCIONES
    //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    // Lista de opciones Estandar
    void optHash(string &valor);
    void optClearHash(string &valor);
    void optUciEngineAbout(string &valor);

    // Lista de opciones extra
    void optResumenBusqueda(string &valor);

    //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //+ DATOS
    //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    vector<ComandoUCI*> listaComandos;
    vector<OpcionUCI*> listaOpciones;
};

}; // namespace UCI
