//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ ControlTiempo.h
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#pragma once

#include "Tiempo.h"

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ class ControlTiempo
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

class ControlTiempo {
public:
    // Constructor
    ControlTiempo(void);

    // Limpia la informacin
    void Limpiar(void);

    // Devuelve el tiempo para la jugada
    TipoTiempo Asignar(Color color) const;

    // Establece el tiempo disponible para las blancas
    void SetDispBlancas(TipoTiempo t);

    // Establece el tiempo disponible para las negras
    void SetDispNegras(TipoTiempo t);

    // Establece un control de tiempo fijo
    void SetTiempoFijo(TipoTiempo t);

    // Establece el incremento por jugada para las blancas
    void SetIncBlancas(TipoTiempo t);

    // Establece el incremento por jugada para las negras
    void SetIncNegras(TipoTiempo t);
    
    // Establece el numero de jugadas para un nuevo control de tiempo
    void SetMovesToGo(int m);

    // Establece un control de tiempo infinito
    void SetInfinito(void);

    // Establece la profundidad mxima de bsqueda
    void SetProfundidad(int prof);

    // Devuelve true si el control de tiempo es infinito
    bool EsInfinito(void) const;

    // Devuelve la profundidad en un control de tiempo por profundidad
    int GetProfundidad(void) const;

private:     
    TipoTiempo tiempoDisponible[2];
    TipoTiempo incremento[2];
    TipoTiempo tiempoFijo;
    bool infinito;
    int movesToGo;
    int profundidad;
};
