//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ Estadisticas.cpp
//+
//+ El control de las estadsticas que genera el motor
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"
#include "Estadisticas.h"

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ namespace Estadisticas
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

EnteroU64 Estadisticas::nodosBusqueda;
EnteroU64 Estadisticas::nodosPerft;
EnteroU64 Estadisticas::nodosQsearch;
EnteroU64 Estadisticas::extensionesJaque;
EnteroU64 Estadisticas::extensionesAmenazaMate;
EnteroU64 Estadisticas::extensionesRespuestaUnicaJaque;
EnteroU64 Estadisticas::extensionesPeonSeptima;
EnteroU64 Estadisticas::extensionesRecaptura;
EnteroU64 Estadisticas::failHighPrimero;
EnteroU64 Estadisticas::failHigh;
EnteroU64 Estadisticas::pvsCompletas;
EnteroU64 Estadisticas::pvsMinimas;
EnteroU64 Estadisticas::pvsRebusquedas;
EnteroU64 Estadisticas::rebusquedasAspiration;
EnteroU64 Estadisticas::hashProbes;
EnteroU64 Estadisticas::hashHitsDP;
EnteroU64 Estadisticas::hashHitsAR;
EnteroU64 Estadisticas::hashStoresDP;
EnteroU64 Estadisticas::hashStoresAR;
EnteroU64 Estadisticas::hashCutsExacto;
EnteroU64 Estadisticas::hashCutsBeta;
EnteroU64 Estadisticas::hashCutsAlpha;
EnteroU64 Estadisticas::podadosSEE;
EnteroU64 Estadisticas::podadosDelta;
EnteroU64 Estadisticas::nullMoveIntentos;
EnteroU64 Estadisticas::nullMoveCutsMax;
EnteroU64 Estadisticas::nullMoveCutsMin;
EnteroU64 Estadisticas::capturasGeneradas;
EnteroU64 Estadisticas::nocapturasGeneradas;
EnteroU64 Estadisticas::evasionesGeneradas;
EnteroU64 Estadisticas::intentosIID;

// Limpia las estadisticas
void Estadisticas::LimpiarEstadisticas(void) {
    nodosBusqueda = 0;
    nodosQsearch = 0;
    nodosPerft = 0;
    extensionesJaque = 0;
    extensionesAmenazaMate = 0;
    extensionesRespuestaUnicaJaque = 0;
    extensionesPeonSeptima = 0;
    extensionesRecaptura = 0;
    pvsCompletas = 0;
    pvsMinimas = 0;
    pvsRebusquedas = 0;
    rebusquedasAspiration = 0;
    failHigh = 0;
    failHighPrimero = 0;
    hashProbes = 0;
    hashHitsDP = 0;
    hashHitsAR = 0;
    hashStoresDP = 0;
    hashStoresAR = 0;
    hashCutsAlpha = 0;
    hashCutsBeta = 0;
    hashCutsExacto = 0;
    podadosSEE = 0;
    podadosDelta = 0;
    capturasGeneradas = 0;
    nocapturasGeneradas = 0;
    evasionesGeneradas = 0;
    nullMoveIntentos = 0;
    nullMoveCutsMax = 0;
    nullMoveCutsMin = 0;
    intentosIID = 0;
}

// Muestra un resumen de estadistica de bsqueda
void Estadisticas::MostrarEstadisticas(void) {
#if defined(DEBUG_MOSTRAR)
    cout << endl;
    cout << "NODOS: Totales: " << nodosBusqueda
         << " Qsearch: " << nodosQsearch << endl;
    cout << "MOVIMIENTOS GENERADOS: Capturas: " << capturasGeneradas
         << " NoCapturas: " << nocapturasGeneradas
         << " Evasiones: " << evasionesGeneradas << endl;
    cout << "EXTENSIONES: Jaque: " << extensionesJaque
         << " Amenaza Mate: " << extensionesAmenazaMate
         << " RespuestaUnicaJaque: " << extensionesRespuestaUnicaJaque << endl;
    cout << "EXTENSIONES: PeonSeptima: " << extensionesPeonSeptima
         << " Recaptura: " << extensionesRecaptura << endl;
    cout << "ORDENADO MOVIMIENTOS: " << static_cast<double>((failHighPrimero*100))/(failHigh+1)
         << "%" << endl;
    cout << "PVS: Completas: " << pvsCompletas
         << " Minimas: " << pvsMinimas
         << " Rebusquedas: " << pvsRebusquedas << endl;
    cout << "ASPIRATION: Rebusquedas: " << rebusquedasAspiration << endl;
    cout << "HASH: Probes: " << hashProbes
         << " HitsDP: " << hashHitsDP << " HitsAR: " << hashHitsAR << endl
         << "      StoresDP: " << hashStoresDP << " StoresAR: " << hashStoresAR << endl;
    cout << "HASH CUTS: Alpha: " << hashCutsAlpha
         << " Beta: " << hashCutsBeta
         << " Exacto: " << hashCutsExacto << endl;
    cout << "PODADOS: SEE: " << podadosSEE
         << " Delta: " << podadosDelta << endl;
    cout << "NULLMOVE: Intentos: " << nullMoveIntentos
         << " CutsMAX: " << nullMoveCutsMax
         << " CutsMIN: " << nullMoveCutsMin << endl;
    cout << "IID: Intentos: " << intentosIID << endl;
    cout << endl;
#endif
}
