//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ FEN.h
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#pragma once

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ class FEN
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

class FEN {
public:
    // Constructor
    FEN(void);
    // Constructor
    FEN(string fen);

    // Lee una cadena FEN alojada en un string y la procesa
    void SetCadena(string fen);

    // Devuelve el estado del tablero para la posicion
    EstadoTablero GetEstado(void) const;
    
    // Devuelve el ply
    int Ply(void) const;

    // Devuelve la pieza en la casilla c
    Pieza GetPieza(Casilla c) const;

    // Devuelve true si el FEN es vlido
    bool EsValida(void) const;

private:
    // Carga los datos desde la cadena FEN leida
    bool Procesar(void);

    // Limpia los datos del objeto
    void LimpiarDatos(void);

    // Establece la pieza en la casilla c
    void Set(Casilla c, Pieza p);

    // La cadena FEN origen
    string cadenaFEN;

    // El tablero, su estado y la cantidad de jugadas realizadas en el 
    Pieza casillas[64];
    EstadoTablero estado;
    int ply;

    // Para detectar errores
    bool posValida;
};
