//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ Hashkeys.cpp
//+ Autor: Federico Corigliano
//+
//+ Las claves Zobrist para las tablas hash y otros usos
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"
#include "Hashkeys.h"
#include "Utils.h"

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ namespace Hashkeys
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

Hashkey Hashkeys::HashPiezas[MAX_PIEZAS][64];
Hashkey Hashkeys::HashEnroque[16];
Hashkey Hashkeys::HashAlPaso[65];
Hashkey Hashkeys::HashMovNulo;

// Inicia las hashkeys
void Hashkeys::IniciarHashKeys() {
    RandomSeed(0xFEDE);
    for(int i = 0; i < MAX_PIEZAS; i++)
        for(int j = 0; j < 64; j++)
            HashPiezas[i][j] = Random64();
    for(int i = 0; i < 16; i++)
        HashEnroque[i] = Random64();
    for(int i = 0; i < 64; i++)
        HashAlPaso[i] = Random64();
    HashAlPaso[64] = 0;
    HashMovNulo = 0xFEDEFEDEFEDEFEDE;
}
