//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ HeavyChess.h
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#pragma once

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ VERSION
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

static const char *VERSION = "0.12 BETA";
static const char *DIVISOR = "----------------------------------------------------------------";

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ OPCIONES DE COMPILACION - DEBUG
//+ Deshabilitar algunas opciones requiere que otras tambien estn deshabilitadas
//+ y tambien al contrario
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#define DEBUG_MOSTRAR               // Mostrar tablero, bitboards y otras salidas por pantalla
//#define CHEQUEO_CONSISTENCIA        // Chequeo de consistencia del tablero y bitboards (falla con NullMove activado)
#define USAR_PERFT                  // Perft, PerftDivide

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ ASSERT
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#if !defined(CHEQUEO_CONSISTENCIA)
#undef assert
#define assert(x)
#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ DEFINICION DE TIPOS
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#if defined(_MSC_VER)
typedef unsigned __int64 EnteroU64;
#else
typedef unsigned long long EnteroU64;
#endif
