//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ Notador.h
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#pragma once

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ DECLARACION PREVIA DE CLASES
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

class Tablero;
class Movimiento;

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ class Notador
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

class Notador {
public:
    // Devuelve las coordenadas en un string (a4, e2, etc) de una casilla en el tablero
    static string ObtenerCoordenadas(Casilla casilla);

    // Devuelve la casilla del tablero correspondiente a unas coordenadas en un string
    static Casilla ObtenerCasilla(string coordenadas);
    
    // Devuelve el figurn de una pieza para el tablero por pantalla
    static string ObtenerFigurin(Pieza pieza);

    // Devuelve la notacin del movimiento en coordenadas
    static string ObtenerNotacion(Movimiento m);
    
    // Devuelve el movimiento legal en el tablero correspondiente a la notacin de coordenadas
    static Movimiento ObtenerMovimiento(string notacion, Tablero &tablero);

private:
    const static string figurinesTablero;
    const static string figurinesPromocion;
};
