//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ Pieza.h
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#pragma once

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ CONSTANTES
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

static const int MAX_PIEZAS = 14;                // Incluyen Vacio
static const int MAX_PIEZAS_DIFERENTES = 7;

// Valor piezas Evaluacion
static const int VALOR_MATERIAL[MAX_PIEZAS] = {
    0, 100, 100, 300, 300, 350, 350, 500, 500, 900, 900, 0, 0, 0
};

// Valor piezas SEE
static const int VALOR_PIEZAS_SEE[MAX_PIEZAS] = {
    0, 100, 100, 300, 300, 300, 300, 500, 500, 900, 900, 0, 0, 0
};

// Valor piezas Conteo
static const int VALOR_PIEZAS[MAX_PIEZAS] = {
    0, 0, 0, 3, 3, 3, 3, 5, 5, 9, 9, 0, 0, 0
};

// Valor peones Conteo
static const int VALOR_PEONES[MAX_PIEZAS] = {
    0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ CONSTANTES ENUMERADAS
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

enum Pieza {
    Vacio, PeonB, PeonN, CaballoB, CaballoN, AlfilB, AlfilN,
    TorreB, TorreN, DamaB, DamaN, ReyB, ReyN, PiezaInvalida
};

enum PiezasUnicas {
    Peon=1, Caballo, Alfil, Torre, Dama, Rey
};

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ Funciones Auxiliares
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

inline bool PiezaValida(Pieza p) { return (p >= Vacio && p <= ReyN); }
inline bool PiezaValidaCasillaAlPaso(Pieza p) { return (p >= Vacio && p <= PiezaInvalida); }
inline Color ColorPieza(Pieza p) { return (p & 1 ? Blancas : Negras); }
