//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ Salida.cpp
//+
//+ Para mostrar contenido por pantalla
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"
#include "Salida.h"

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ class Log
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// Constructor
Log::Log(void) {
    logActivado = false;
}

// Activa el log
bool Log::Activar(void) {
    if(logActivado)
        return true;

    archivoLog.open("heavychess.log", ios_base::app);
    if(!archivoLog.is_open())
        return false;

    logActivado = true;
    archivoLog.setf(ios::unitbuf);
    return logActivado;    
}

// Desactiva el log
void Log::Desactivar(void) {
    archivoLog.close();
    logActivado = false;    
}

// Para escribir en el log
void Log::EscribirLog(char c) {
    if(logActivado)
        archivoLog << c;
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ class SalidaDual
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

SalidaDual::SalidaDual(void) : ostream(this) { }

Log& SalidaDual::GetLog(void) {
    return log;
}
