//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ Salida.h
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#pragma once

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ class Log
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

class Log {

public:
    // Constructor
    Log(void);

    // Activa el logging
    bool Activar(void);

    // Desactiva el logging
    void Desactivar(void);

    // Para escribir en el log
    void EscribirLog(char c);
        
private:
    ofstream archivoLog;
    bool logActivado;
};

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ class SalidaDual
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

class SalidaDual : public ostream, private streambuf {
public:
    // Constructor
    SalidaDual(void);

    // Accesa al log
    Log& GetLog(void);

    // Informa que una nueva profundidad se ha alcanzado
    virtual void NuevaProfundidadBusqueda(int prof) = 0;

    // Informa que se est estudiando un nuevo movimiento en raz
    virtual void NuevoMovimientoRaiz(Movimiento m, int numMovimiento, EnteroU64 nodos) = 0;

    // Informa que se ha encontrado una nueva variante principal
    virtual void NuevaVariantePrincipal(int prof, int profSelectiva, TipoTiempo tiempoTranscurrido,
                                        EnteroU64 nodos, double utilizacionHash, int puntaje,
                                        bool esMate, string pv) = 0;

    // Informa el mejor movimiento devuelto
    virtual void DevolverMejorMovimiento(Movimiento mov, Movimiento ponder) = 0;               

private:

    // Funcin necesaria para la dualidad cout-log
    int overflow(int i) {
        char c = static_cast<char>(i);
        cout.write(&c, 1);
        log.EscribirLog(c);
        return i;
    }

    Log log;
};
