//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ SalidaUCI.h
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#pragma once

#include "Salida.h"

namespace UCI {

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ class SalidaUCI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

class SalidaUCI : public SalidaDual {
public:
    // Informa que una nueva profundidad se ha alcanzado
    virtual void NuevaProfundidadBusqueda(int prof);

    // Informa que se est estudiando un nuevo movimiento en raz
    virtual void NuevoMovimientoRaiz(Movimiento m, int numMovimiento, EnteroU64 nodos);

    // Informa que se ha encontrado una nueva variante principal
    virtual void NuevaVariantePrincipal(int prof, int profSelectiva, TipoTiempo tiempoTranscurrido,
                                        EnteroU64 nodos, double utilizacionHash, int puntaje,
                                        bool esMate, string pv);

    // Informa el mejor movimiento devuelto
    virtual void DevolverMejorMovimiento(Movimiento mov, Movimiento ponder);               
};

}; // namespace UCI
