//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ TableroDebug.h
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#pragma once

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ DECLARACION PREVIA DE CLASES
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

class Tablero;
class Motor;
class Consola;

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ class TableroDebug
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

class TableroDebug {
public:
    // Constructor
    TableroDebug(const Tablero& tablero, Motor &motor);

    // Muestra los bitboards
    void MostrarBitboards(void) const;

    // Muestra el tablero por pantalla
    void Mostrar(void) const;

    // Muestra una lista de movimientos legales
    void MostrarMovimientosLegales(void) const;

    // Chequea la consistencia de las estructuras internas para encontrar bugs
    bool ChequearConsistencia(void) const;

    // Muestra el codigo de error del chequeo de consistencia
    void MostrarCodigoError(int codigoError) const;

private:
    // Acceso a la consola
    Consola& GetConsola(void) const;

    Motor     &motor;
    const Tablero   &tablero;
};
