//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ Tiempo.cpp
//+
//+ Almacena el tiempo para el calculo de interalos de tiempo
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"
#include "Tiempo.h"

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ class Tiempo
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// Constructor
Tiempo::Tiempo(void) {
    m_Tiempo = 0;
}

// Constructor
Tiempo::Tiempo(TipoTiempo t) : m_Tiempo(t) {}

// Guarda en la variable tiempo, el tiempo actual
void Tiempo::AsignarTiempoActual(void) {
	m_Tiempo = Ahora();
}

// Sobrecarga operador asignacion
Tiempo Tiempo::operator=(const TipoTiempo t) {
    m_Tiempo = t;
    return *this;
}

// Sobrecarga operador igualdad
bool Tiempo::operator==(const TipoTiempo t) {
    return (m_Tiempo == t);
}

// Sobrecarga operador desigualdad
bool Tiempo::operator!=(const TipoTiempo t) {
    return (m_Tiempo != t);
}

// Sobrecarga operador /
Tiempo Tiempo::operator/(const int i) {
    return Tiempo(m_Tiempo / i);
}

// Sobrecarga operador +
Tiempo Tiempo::operator+(const Tiempo t) {
    return Tiempo(m_Tiempo + t.m_Tiempo);
}

// Devuelve la difencia con el tiempo real
TipoTiempo Tiempo::Transcurrido(void) const {
	return (Ahora()-m_Tiempo);
}

// Devuelve el tiempo actual. til si no se quieren utilizar objetos
TipoTiempo Tiempo::Ahora(void) {
#ifdef WIN32
	return(TipoTiempo)(GetTickCount());
#endif
}
