//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ Tiempo.h
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#pragma once

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ DEFINICIN DE TIPOS
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

typedef unsigned long int TipoTiempo;

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ MACROS
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

inline double Segundos(TipoTiempo t) { return (static_cast<double>(t)/1000); }

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ class Tiempo
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

class Tiempo {
public:
	// Constructor
	Tiempo(void);
    Tiempo(TipoTiempo t);

	// Guarda en la variable tiempo, el tiempo actual
	void AsignarTiempoActual(void);
	
    // Sobrecarga operador asignacion
    Tiempo operator=(const TipoTiempo t);

    // Sobrecarga operador igualdad
    bool operator==(const TipoTiempo t);

    // Sobrecarga operador desigualdad
    bool operator!=(const TipoTiempo t);

    // Sobrecarga operador /
    Tiempo operator/(const int i);

    // Sobrecarga operador +
    Tiempo operator+(const Tiempo t);

    // Devuelve la difencia con el tiempo real
	TipoTiempo Transcurrido(void) const;

    // Devuelve el tiempo actual. til si no se quieren utilizar objetos
	static TipoTiempo Ahora(void);

private:
	TipoTiempo m_Tiempo;
};
