//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ Utils.cpp
//+
//+ Funciones extra independientes del motor
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

// Funcion auxiliar utilizada para tokenizar un string. Tomada de
// http://www.digitalpeer.com/id/simple y traducida
vector<string> Tokenizar(const string& str, const string& delimitadores) {
	vector<string> tokens;
   	string::size_type ultimo = str.find_first_not_of(delimitadores, 0);
    string::size_type pos = str.find_first_of(delimitadores, ultimo);
    while (pos != string::npos || ultimo != string::npos) {
    	tokens.push_back(str.substr(ultimo, pos-ultimo));	
    	ultimo = str.find_first_not_of(delimitadores, pos);	
    	pos = str.find_first_of(delimitadores, ultimo);
    }
	return tokens;
}

// Funcin auxiliar que devuelve la primer palabra de un string
string PrimerPalabra(const string& str) {
    string::size_type pos = str.find_first_of(" ");
    return str.substr(0, pos);
}

// Funcin auxiliar utilizada para cnvertir un string a un entero
int StringAEntero(const string& str) {
    int ret;
    istringstream iss(str);
    iss >> ret;
    return ret;
}

// Funcin auxiliar utilizada para cnvertir un entero a un string
string EnteroAString(const int i) {
    stringstream ss;
    ss << i;
    return ss.str();
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ GENERACION DE NMEROS AL AZAR
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// Devuelve un numero al azar de 15 bits
inline EnteroU64 Rand15(void) {
    return (static_cast<EnteroU64>(rand()) & static_cast<EnteroU64>(0x7fff));
}

// Devuelve un EnteroU64 al azar
EnteroU64 Random64(void) {
    return Rand15() ^ (Rand15() << 15) ^ (Rand15() << 30) ^ (Rand15() << 45) ^
          (Rand15() << 60);
}

// Establece la semilla para el generador de nmero al azar
void RandomSeed(unsigned int seed) {
    srand(seed);
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+ FUNCIONES STRINGS
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// Devuelve una cadena con "true" o "false" segun el valor de verdad del argumento
string ValorVerdad(bool arg) {
    return (arg ? string("true") : string("false"));
}
